<?php if(!defined('_VALID')){header('Status: 404 Not Found');die;}

include $d_root.'admin/classes/coreinstall.php';

class UnInstall extends CoreInstall {
	var $uninstall_string = null;

	function UnInstall($type, $fname = null) {
		parent::CoreInstall();
		$this->type = $type;
		$this->uninstall_string = $fname;
	}

	function name($fname) {
		$this->uninstall_string = $fname;
	}

	function go(){
		$mth = 'uninstall_'.$this->type;
		return $this->$mth();
	}
	
	function uninstall_module() {
		global $d_root, $conn;
		if (!$this->fs->unlink($d_root . "modules/" . $this->uninstall_string . ".php"))
				return _UNINSTALL_FAILED;
		$dir=read_dir($d_root . "modules/",'file');
		foreach($dir as $file){
			if(strstr($file,$this->uninstall_string)) {
				$this->fs->unlink($d_root.'modules/'.$file);
			}
		}
		$sql = 'DELETE FROM #__modules WHERE module=\''.$this->uninstall_string.'\'';
		$conn->Execute($sql);
		$this->_subsites_sync($sql);
		return _UNINSTALL_SUCCESS;
    }

   function uninstall_drabot()
    {
        global $d_root, $conn;
        if (!$this->fs->unlink($d_root . "drabots/" . $this->uninstall_string . ".php"))
			return _UNINSTALL_FAILED;
		//check for other similar files ( delete them 2 )
		$files = safe_glob($d_root.'drabots/'.$this->uninstall_string.'*.*');
		foreach($files as $file) {
			if (!$this->fs->unlink($file))
				return _UNINSTALL_FAILED;
		}
	    $sql = 'DELETE FROM #__drabots WHERE element=\''.$this->uninstall_string.'\'';
		$conn->Execute($sql);
		$this->_subsites_sync($sql);
		if (!$this->fs->unlink($d_root . "drabots/" . $this->uninstall_string . ".xml"))
			return _UNINSTALL_FAILED;
		return _UNINSTALL_SUCCESS;
    }

    function uninstall_template()
    {
        global $d_root;
        if ($this->fs->deldir($d_root . "templates/" . $this->uninstall_string . "/")) return _UNINSTALL_SUCCESS;
        else return _UNINSTALL_FAILED;
    }
    function uninstall_language()
    {
        global $d_root;
        if ($this->fs->deldir($d_root . "lang/" . $this->uninstall_string . "/"))return _UNINSTALL_SUCCESS;
        else return _UNINSTALL_FAILED;
    }
    function uninstall_component()
    {
        global $d_root, $conn, $d_private;
        $uninstall_dir = $d_root.'admin/components/'.$this->uninstall_string.'/';
        $this->from_dir($uninstall_dir);
		if (!$this->findInstallFile())
			return _INSTALL_INVALID;

        $uninstallfile_element = $this->xml->getElementByPath('uninstallfile');
        if (isset($uninstallfile_element)) {
            if (is_file($d_root . $d_private . $uninstallfile_element->getValue())) {
                $this->fs->unlink($d_root . $d_private . $uninstallfile_element->getValue());
            }
            copy($uninstall_dir . $uninstallfile_element->getValue(), $d_root . $d_private . $uninstallfile_element->getValue());
        }
        $this->queries($this->xml, 'uninstall/queries');
        $this->fs->deldir($uninstall_dir);
        $this->fs->deldir($d_root . "components/" . $this->uninstall_string . "/");

		$module_element = $this->xml->getElementByPath('modules');
        if (isset($module_element)) {
            $modules = $module_element->getAllChildren();
            foreach($modules as $module) {
				$muninstall=new UnInstall("module");
				$muninstall->name($module->getValue());
				$muninstall->go();
            }
   	    }

		$drabot_element = $this->xml->getElementByPath('drabots');
        if (isset($drabot_element)) {
			$drabots = $drabot_element->getAllChildren();
            foreach($drabots as $drabot) {
				$muninstall=new UnInstall("drabot");
				$muninstall->name($drabot->getValue());
				$muninstall->go();
            }
   	    }

		$sql = "DELETE FROM #__components WHERE option_link='" . $this->uninstall_string . "'";
        $conn->Execute($sql);
		$this->_subsites_sync($sql);

        if (isset($uninstallfile_element)) {
            return '&uninstall_file=' . $d_root . $d_private . $uninstallfile_element->getValue();
        }
        return _UNINSTALL_SUCCESS;
    }
}

?>