<?php if(!defined('_VALID')){header('Status: 404 Not Found');die;}
## LDAPBase class
# @author legolas558
# original @author countnikon@phpfreaks.com
#
# LDAP authentication and query facilities
#

/*
global $d__ldap_resources, $d__ldap_clean;
$d__ldap_resources = array();
$d__ldap_clean = false;

function _free_ldap() {
	global $d__ldap_resources;
	foreach($d__ldap_resources as $ldap_bind)
		ldap_close($ldap_bind);
	return true; // unnecessary?
}
*/

class LDAPBase {
	var $ldapConn; //ldap connection storage variable
	var $ldapBind; //ldap bind storage variable
	var $entries;	//ldap entries variable
	var $ldapLookupUser;
	var $ldapLookupPass;
	var $server;
	var $port;
	var $by;
	var $search;
	var $baseDN;

	function LDAPBase($server,$port,$baseDN) {
		$this->server=$server;
		$this->port=$port;
		$this->baseDN=$baseDN;
	}
	
	function Error() {
		return $this->ldapError;
	}

	function Connect() {
		$this->ldapConn = @ldap_connect($this->server,$this->port);
		// it is unlikely to experience a failure here, new LDAP implementations perform actual connection upon other ldap_* functions
		if ($this->ldapConn === false)
			$this->ldapError = _LDAP_CONNECT_FAILED;
		return $this->ldapConn;
	}

	function Bind($ldapLookupUser,$ldapLookupPass) {
		if (!$this->Connect())
			return false;
		$res = @ldap_bind($this->ldapConn,$ldapLookupUser,$ldapLookupPass);
		if ($res) {
			$this->ldapBind = $res;
/*			global $d__ldap_resources, $d__ldap_clean;
			$d__ldap_resources[] = $res;
			if (!$d__ldap_clean)
				register_shutdown_function('_free_ldap');	*/
			return true;
		} else {
			$this->ldapError = ldap_error($this->ldapConn);
			return false;
		}
	}
	
	//NOT YET USED
	function Search($by,$search,$ous,$searchby) {
		$c=0;
		foreach($ous as $ou) {
			$read=ldap_search($this->ldapConn,"ou=$ou,$this->baseDN", "$searchby=*$search*");
			$entries = ldap_get_entries($this->ldapConn, $read);
			for ($i=0; $i<$entries["count"]; $i++)
			{
				if($entries[$i][$by][0])
					$values[$c]=$entries[$i][$by][0];
				++$c;
			}
		}
		return $values;
	}

} // class LDAPBase

class LDAPAuth extends LDAPBase {
	
	function LDAPAuth($server,$port,$baseDN) {
		parent::LDAPBase($server, $port, $baseDN);
	}
	
	function Authenticate($username,$password) {
		if (!$this->Bind($username, $password))
			return false;
		ldap_unbind($this->ldapBind);
		return true;
	}
	
}

?>