<?php if(!defined('_VALID')){header('Status: 404 Not Found');die;}
## Thumbnailer class
# @author legolas558
# @version 0.1
# Released under GNU/GPL License
# This component is part of Drake CMS core
#
# thumbnail generation code
#

define('_GALLERY_THUMBNAIL_SIZE', 100);

class Thumbnailer {
	function calcsize ($maxsize,$imscr) {
	  $im_stat = GetImageSize($imscr);

	  if ($maxsize == 0) {
	    $th_w = $im_stat[0];
	    $th_h = $im_stat[1];
	  } else {

	    if ($im_stat[0] <= $im_stat[1]) {
	      $th_h = $maxsize;
	      $th_ratio = ($im_stat[1] / $maxsize);
	      $th_w = round($im_stat[0] / $th_ratio);
	    } else {
	      $th_w = $maxsize;
	      $th_ratio = ($im_stat[0] / $maxsize);
	      $th_h = round($im_stat[1] / $th_ratio);
	    }
	  }
	  return array ($th_h,$th_w);
	}

	function resize_image($src, $dest, $max_sz) {
		if (function_exists('ImageJPEG')) {
		    $im_stat = GetImageSize($src);
		    $width  = $im_stat[0];
		    $height = $im_stat[1];
		    list ($h,$w) = Thumbnailer::calcsize ($max_sz,$src);
			switch($im_stat[2]) {
				case 1:
					$im = @ImageCreateFromGIF ($src);
				break;
				case 2:
					$im = @ImageCreateFromJPEG ($src);
				break;
				case 3:
					$im = @ImageCreateFromPNG ($src);
				break;
				default:
					// 4 = SWF
					trigger_error('Unsupported format: '.$im_stat[2]);
					return false;
			}
			// quit if an unrecoverable error has happened
			if (!$im) return false;
			$imnew = ImageCreatetruecolor($w,$h);
			imagecopyresampled ($imnew,$im,0,0,0,0,$w,$h,$im_stat[0],$im_stat[1]);
			ImageJPEG($imnew,$dest,65);
			ImageDestroy($im);
			ImageDestroy($imnew);
			return true;
		} else { // use thumbnail .NET wrapper
			global $d_website,$d_root,$d_private;
			$rk = random_string(7);
			$temp_holder = $d_root.$d_private.'temp/'.$rk.'.tmp';
			$kf = fopen($temp_holder,'w');
			fputs($kf,$src);
			fclose($kf);
			$aspxurl = $d_website.'classes/thumbnailer/thumb.aspx?key='.$rk.
								'&max='.$max_sz;
			$thumbnail = get_url($aspxurl);
			unlink($temp_holder);
			if (($thumbnail===false) || (strlen($thumbnail)===0)) {
				global $d;
				$d->log(4, _THUMBNAILER_ASPNET_FAIL);
				return false;
			}
			if ($thumbnail[0]=='<') {
				global $d;
				$d->log(4, sprintf(_THUMBNAILER_ASPNET_NA, $src));
				return false;
			}
			return file_put_contents($dest, $thumbnail);
		}
	}
	
	function make_thumbnail_from_url(&$fs, $url, $thumbs_path) {
		global $d_temp;
		$fname = clear_name($url);
		$dest = $d_temp.random_string(7).'_'.$fname;
		if (get_url($url, $dest))
			return Thumbnailer::resize_image($dest, $thumbs_path.$fname,_GALLERY_THUMBNAIL_SIZE) && $fs->unlink($dest);
	}

}

?>