<?php if(!defined('_VALID')){header('Status: 404 Not Found');die;}

define('_LOGIN_MAX_ATTEMPTS', 20);	// maximum number of login attempts

class CMSUser {

	var $id=false;
	var $captcha_ok;
	var $gid=0;
	var $username='';
	var $name='';
	var $email='';
	var $lang = 'en';
	var $ip;
	var $timezone;
	//groups 1 = registered , 2 = editor  , 3 = publisher , 4 = manager , 5 = admin

	function setLangCookie($lang) {
		$this->lang = $lang;
		d_setcookie( 'user_lang', $lang, 60*15);
	}

	function _cookie_lang() {
		global $d_root;
		// start user change language
		$lang = in_cookie('user_lang', '', 2);
		
		if (strlen($lang)) {
			$lang = path_safe($lang);
			if (is_file($d_root.'lang/'.$lang.'/language.xml')) {
				$this->setLangCookie($lang);
				return true;
			} else
				d_unsetcookie('user_lang');
		}
		return false;
	}

	function recognize_lid() {
		global $d_root;
		$hdr = @$_SERVER["HTTP_ACCEPT_LANGUAGE"];
		if (empty($hdr)) return $GLOBALS['d_deflang'];

		if (!preg_match_all('/([a-z]{2})/', $hdr, $m))
			return $GLOBALS['d_deflang'];

		foreach( $m[0] as $lid ) {
			$lang=strtolower($lid);
			if (file_exists($d_root.'lang/'.$lang.'/language.xml'))
				return $lang;
		}
		return $GLOBALS['d_deflang'];
	}

	function _valid_lang($lang) {
		if (is_file($GLOBALS['d_root'].'lang/'.$lang.'/language.xml'))
			return $lang;
		return $this->recognize_lid();
	}

	function GetIP() {
		global $d_root;
		if (!isset($this->ip)) {	// please keep curly braces
			$this->ip = include($d_root.'includes/retrieve_ip.php');
		}
		return $this->ip;
	}
	
	## used to prevent 0 not being written
	function GetID() {
		if (!$this->id)
			return "0";
		return (string)$this->id;
	}

	function initlogin(&$row) {
		global $d_uid;
		//DEBUG
		if (!count($row)) {
			global $d_root;
			include_once $d_root.'classes/http.php';
			CMSResponse::ServiceFatal('500 Server Error', 'Database is corrupted (E001)');
			return false;
		}
		$this->gid = $row['gid'];
		$this->name=$row['name'];
		$this->username=$row['username'];
		$this->email=$row['email'];
		
		if (!$this->_cookie_lang())	
			$this->lang = $this->_valid_lang($row['lang']);
		//DEBUG
		if (!$this->lang) {
			global $d_root;
			include_once $d_root.'classes/http.php';
			CMSResponse::ServiceFatal('500 Server Error', 'Database is corrupted (E002)');
			return false;
		}

		$this->timezone = $row['timezone'];

		// the following workaround should prevent some glitchy PHP behaviours
		$id = $this->id;
		$_SESSION[$d_uid.'-uid'] = $id;
		
		return true;
	}

	// check the POST if a 'remember' flag was specified
	// in such case, set the cookies for username and hashed password
	// this function is currently called by com_login
	function remember() {
		if (!$this->gid)
			return;
	//	$etime=60*15; // fifteen minutes
		if (isset($_POST['remember'])) {
			global $conn, $d_uid;
			$row = $conn->SelectRow('#__users', 'password', ' WHERE id='.$this->id);
			$etime=3600*24*14;
			global $d_uid;
			d_setcookie('cusername',$this->username, $etime);
			d_setcookie('cpassword',md5($d_uid.$row['password']), $etime);
			d_setcookie('cremember', 1, $etime);
		}
	}
	
//	function CMSUser() {	}

	// the initializer
	function Initialize($cookie_login = true) {
		global $d_uid;
		// retrieve user id from session object
		$finished = false;
		if (isset($_SESSION[$d_uid.'-uid'])	) {
			$this->id = (int)$_SESSION[$d_uid.'-uid'];
			global $conn;
			$row=$conn->SelectRow('#__users', 'gid,name,username,password,email,lang,timezone', ' WHERE id='.$this->id);
			// the session contains an invalid ID, clean it up
			//NOTE: no validation is performed on session uid, because it must be trusted data
			if (!count($row))
				unset($_SESSION[$d_uid.'-uid']);
			else if ($this->initlogin($row)) {
				$this->_cookie_lang();
				$finished = true;
			}
		}
		
		if ($cookie_login) {
			if (!$finished) {
				$cusername = in_cookie('cusername');
				$cpassword = in_cookie('cpassword');
				if (isset($cusername) && isset($cpassword)) {
					global $conn;		
					$row=$conn->SelectRow('#__users', 'id,gid,name,username,password,email,lang,timezone', ' WHERE username=\''.sql_encode($cusername).'\'');
					if (count($row)) {
						if ($cpassword===md5($GLOBALS['d_uid'].$row['password'])) {
							$this->id=$row['id'];
							$this->lang = $this->_valid_lang($row['lang']);
							if ($this->initlogin($row)) {
								$finished = true;
							}
						}
					}
				}
			}
			
			if (!$finished) {
				if (!$this->_cookie_lang())
					$this->lang = $this->recognize_lid();
			}
		} else
			$this->lang = $this->recognize_lid();
	}

	function http_logout($destination) {
		header('HTTP/1.0 401 Unauthorized', false);
		header('WWW-Authenticate: Bogus', false);
		global $d, $d_website, $d_rand;
		$url = $d_website.$destination;
	//	$p = strpos($url, '//');
	//	$url = substr($url, 0, $p+2).$d_rand.'-logout:logout@'.substr($url, $p+2);
		CMSResponse::Redir($url);
	}

	function Logout($admin = false) {
		global $d_stats,$d_uid, $d_http_auth;
		d_unsetcookie('cusername');
		d_unsetcookie('cpassword');
		d_unsetcookie('cremember');
		if ($d_stats) {
			global $conn;
			$conn->Delete('#__simple_stats', " WHERE id>1 AND ip='".$this->GetIP()."'");
		}
		$GLOBALS['_SESSION'][$d_uid.'-uid'] = null;
		$prev_url = $this->PreviousPage($admin, true);
		if ($d_http_auth)
			$this->http_logout($prev_url);
		else
			CMSResponse::Redir($prev_url);
	}

	function PreviousPage($admin = true, $out = false) {
		global $d_website;
		// go back to the previous page (if any)
		$referer = CMSRequest::Referer();
		if (isset($referer)) {
			$redir = strtolower($referer);
			if (strpos($redir, $d_website)===0) {
				$redir = substr($redir, strlen($d_website));
				if ($redir[0]=='/') $redir = substr($redir, 1);
				if (strpos($redir, 'index.php')===0)
					return $redir;
				if (strpos($redir, 'admin.php')===0) {
					if (!$admin || $out)	return 'index.php';
					return $redir;
				}
			}
		}
		if (!$admin || $out)
			return 'index.php';
		return 'admin.php';
	}

	// compares the captcha and returns its validity
	function valid_captcha() {
		global $d_uid;
		
		if (!isset($this->captcha_ok))
			$this->captcha_ok = (isset($_SESSION[$d_uid.'-captcha']) &&
							isset($_POST['code']) &&
							($_SESSION[$d_uid.'-captcha'] === md5(raw_strtoupper(@$_POST['code']))));
		if (!$this->captcha_ok) {
			CMSResponse::Back(_CAPTCHA_INCORRECT_CODE);
		}
		return $this->captcha_ok;
	}

	function _can_retry() { return $this->CanLogin(); }

	function CanLogin() {
		global $d_uid;
		$trials = in_session('trials');
		if (!isset($trials))
			return true;
		if ($trials==_LOGIN_MAX_ATTEMPTS) {
			global $d;
			$d->log(LOG_WARNING, 'Massive login trials ('.$_SESSION[$d_uid.'-trials'].' attempts), further requests will be refused');
		}
		if ($trials>_LOGIN_MAX_ATTEMPTS)
			return false;
		// user can keep trying to log in
		return true;
	}

	var $_login_msg;

	function Login($min_gid = 1, &$_S, $relayed = false) {
		global $d;
		
		if (!$relayed) {
			$p = $d->GetComponentParamsRaw('login');
			// if the captcha check is enabled for the login component, check it
			if ($p->get('captcha', 0) and !$this->valid_captcha())
				return false;
		}

		if ($min_gid>=3)
			$prev_url = 'admin.php';
		else $prev_url = 'index.php?option=login';
		if ('' === ($username = trim(in_sql('username', $_S, '', 25))) ||
			'' === ($password = in_raw('password', $_S, '', 100)) ) {
			if (!$relayed) {
				CMSResponse::Redir($prev_url, _LOGIN_INCOMPLETE);
			}
			// will not record this as an attempt
			return false;
		}
		
		$success  = $this->CanLogin();
		if (!$success) {
			$this->_failed_attempt();
			CMSResponse::Forbidden();
			return false;
		} else // these are the standard steps to be performed for a valid login procedure
			$success = $this->ActualLogin($username, $password, $min_gid);
		$this->FinalizeLogin($success, $min_gid, $prev_url);
		return $success;	
	}
	
	function _failed_attempt() {
		// brute force attacks prevention
		$trials = in_session('trials', 0);
		out_session('trials', $trials+1);
	}

	function FinalizeLogin($success, $min_gid, $prev_url = null) {
		if (!$success) {
			$this->_failed_attempt();
			global $d_http_auth;
			if (!$d_http_auth)
				CMSResponse::Redir($prev_url, $this->_login_msg);
		} else {
			global $d_uid;
			if (isset($_SESSION[$d_uid.'-trials']))
				unset($_SESSION[$d_uid.'-trials']);
			$this->remember();
			global $d_stats, $time;
			if ($d_stats) {
				global $conn;
				$conn->Update('#__users', 'lastvisitDate ='.$time, " WHERE id = ".$this->id);
			}
			// perform redirection after login
			CMSResponse::Redir($this->PreviousPage(($min_gid>=3)));
		}
	}
	
	function _get_user_row($username) {
		global $conn;
		return $conn->SelectRow('#__users', '*', ' WHERE username=\''.sql_encode($username).'\'');
	}

	## finalize login operation checked elsewhere (e.g. in other authentication plugin)
	## when using this method no password check is performed
	function RelayedLogin($success, $username, $min_gid) {
		if ($success) {
			$row = $this->_get_user_row($username);
			if (!$this->CMSLogin($row, $min_gid))
				$success = false;
		}
		if ($min_gid>=3)
			$prev_url = 'admin.php';
		else $prev_url = 'index.php?option=login';

		$this->FinalizeLogin($success, $min_gid, $prev_url);
		return $success;
	}
	
	## implemented for safe RPC logins
	## $username must NOT be sql-encoded
	function ActualLogin($username, $password, $min_gid = 1) {
		global $_DRABOTS;
		
		// load bots which could override the default login mechanism
		$results = $_DRABOTS->trigger('onAuthenticateOverride', array($username, $password, $min_gid));
		$override = false;
		foreach($results as $result) {
			// successful authentication override and successful login
			if ($result === true) {
				$override = true;
				continue;
			}
			// the function choose to not take over the override, but some other function might have
			if ($result === false)
				continue;
			// the function took over the authentication override, failed login and returned an error (string)
			$this->_login_msg = $result;
			return false;
		}
		
		if (!$override) {
			global $conn;
			$row = $conn->SelectRow('#__users', '*', " WHERE username = '".sql_encode($username)."' AND password = '".md5($password)."'");
			if (!count($row)) {
				$this->_login_msg = _LOGIN_INCORRECT;
				return false;
			}
		} else // the existance of this user has already been checked by the overrider function when calling User::ClearPwCheck()
			$row = $this->_get_user_row($username);
		
		return $this->CMSLogin($row, $min_gid, $override);
	}

	## when previous checks have allowed the login, check if the user is enabled and/or if further authentication succeeds
	function CMSLogin(&$rsa, $min_gid, $override = false) {
		if ($rsa['gid']<$min_gid) {
			//TODO: use HTTP error instead?
			$this->_login_msg = _UNAUTHORIZED_ACCESS;
			return false;
		}
	
		if (!$rsa['published']) {
			$this->_login_msg = _LOGIN_BLOCKED;
			return false;
		}
		
		// if the login has not been checked before, then perform the authentication here
		// examples:
		// DIGEST AUTH + LDAP: check clear password in DB (for Digest Auth) + run onAuthenticate LDAP ($override = false here)
		// BASIC AUTH + LDAP: override in ActualLogin (for Basic Auth) using LDAP + do not run onAuthenticate ($override = true here)
		// NORMAL POST + LDAP: override in ActualLogin using LDAP + do not run onAuthenticate ($override = true here)
		if (!$override) {
			// load core drabots (for authentication plugins)
			global $_DRABOTS;
			
			$results = $_DRABOTS->trigger('onAuthenticate', $rsa);
			
			foreach($results as $result) {
				if ($result !== '') {
					$this->_login_msg = $result;
					return false;
				}
			}
		}

		$this->id=$rsa['id'];
		global $d_stats;
		if ($d_stats) {
			global $conn;
			$conn->Execute("DELETE FROM #__simple_stats WHERE id>1 AND ip='".$this->GetIP()."'");
		}
		$this->initlogin($rsa);
		return true;
	}

	function GetPassword($username) {
		global $conn;
		$row = $conn->SelectRow('#__users', 'clear_password', ' WHERE username=\''.sql_encode($username).'\'');
		if (!isset($row['clear_password']))
			return null;
		$pw = $row['clear_password'];
		if (!$this->ClearPwCheck($pw))
			return false;
		return $pw;
	}
	
	function ClearPwCheck($pw) {
		if (!strlen($pw)) {
			global $d_clear_pw;
			CMSResponse::Unavailable(_LOGIN_CLEAR_PW_REQUIRED.'<br />'.
							($d_clear_pw ? _LOGIN_CHANGE_PW : _LOGIN_CLEAR_PW_DISABLED));
			return false;
		}
		return true;
	}

	function admin_login($data) {
		// administrative login for publisher, manager and admin users
		return $this->login(3, $data);
	}

	function isuser()
	{
		if ($this->id)
			return true;
		else
			return false;
	}

	## tells if an editor can edit a content item
	function can_edit($owner) {
		// return true if editor AND owner of element
		if ($this->gid==2 && $this->id==$owner)
			return true;
		// return true if publisher or above
		return ($this->gid>2);
	}
	
	## tells if user is allowed to publish
	function can_publish() {
		return ($this->gid>=2);
	}
	
	## tells if user is allowed to submit
	function can_submit() {
		return ($this->gid>=1);
	}
	
	function is_admin() { return ($this->gid==5); }

	function GetTimezone() {
		return (isset($this->timezone) ? $this->timezone : constant('_LOCALE_DEFAULT_TIMEZONE'));
	}
	
	// information shown on the logs about this user impersonation
	function LogInfo() {
		if (!$this->id)
			return 'Anonymous (IP '.$this->GetIP().')';
		return sprintf('User %s (ID #%d)', $this->username, $this->id);
	}


} // CMSUser class

?>