<?php if(!defined('_VALID')){header('Status: 404 Not Found');die;}
## Forum component for Drake CMS
# @author legolas558
# Released under GNU GPL License
# This component is part of Drake CMS core
#
# This file contains the functions used by other renderer functions
#

define('_FORUM_MAXIMUM_UPLOADED_AVATAR', 600*1024);

function _layout_wrap_cb($m) {
	if (!preg_match('/^\w+="/', $m[0]))
		return chunk_split($m[0], 65);
	return $m[0];
}

## splits the message so that does not break the layout with scrollbars
function layout_wrap($s, $columns = 65) {
	return preg_replace_callback('/[^\s]{'.($columns+1).',}/', '_layout_wrap_cb',
							wordwrap($s, $columns));
}

function html_forum_date($ts) {
	return lc_strftime(_FORUM_DATE_FORMAT_LC, $ts);
}

function remove_bb($s) {
	return preg_replace('/\\[.+?\\]/','',$s);
}

global $forum_moderators;
$forum_moderators = array();

//global $master_moderators;
//$master_moderators = array_map('trim', explode(',',$params->get('moderators'));

function get_thread_id($post_id) {
	global $conn;
	$crow=$conn->GetRow("SELECT thread_id FROM #__forum_posts WHERE id=".$post_id);
	if (!count($crow)) return 0;
	$thread_id=$crow['thread_id'];
	if($thread_id==0) return $post_id;
	return $thread_id;
}

## estabilish if an user can post into a topic
function can_user_post($edit_gid, $locked, $catid) {
	global $my;
	// managers and above can post anywhere
	if ($my->gid>3)
		return true;
	// if the forum is locked, moderator rules apply
	if ($locked) return is_forum_moderator($catid, $my->username);
	
	// otherwise the edit group id is respected
	return ($my->gid>=$edit_gid);
}

function can_user_post_into_cat($catid) {
	global $conn, $access_sql;
	// retrieve topic data
	$row = $conn->SelectRow('#__forum_categories', 'editgroup,locked', ' WHERE id='.$catid.' '.$access_sql);
	if (!count($row)) {
		global $d;
		CMSResponse::Unauthorized();
		return false;
	}

	// check if user has enough priviledges to post
	if (!can_user_post($row['editgroup'], $row['locked'], $catid)) {
		global $d;
		CMSResponse::Unauthorized();
		return false;
	}
	
	return true;
}

function notify_change($user_notify, $topic_id) {
	global $conn,$my;
	//L: update notification flag
	if ($user_notify) {
		if (!get_db_notify($topic_id))
			$conn->Insert('#__forum_notifies', '(user_id, topic_id)', $my->id.', '.$topic_id);
	} else
		$conn->Delete('#__forum_notifies', ' WHERE user_id='.$my->id.' AND topic_id='.$topic_id);
}

function &get_forum_moderators($catid) {
	global $forum_moderators;
	if (!isset($forum_moderators[$catid])) {
		global $conn;
		$row=$conn->SelectRow('#__forum_categories', 'moderators', ' WHERE id='.$catid.' AND moderators<>\'\'');
		if (!$row) {
			$forum_moderators[$catid] = array();
			return $forum_moderators[$catid];
		}
		$forum_moderators[$catid] = array_map('trim', explode(',',$row['moderators']));
	}
	//return array_merge($GLOBALS['master_moderators'], $forum_moderators[$catid]);
	return $forum_moderators[$catid];
}

// returns true if $name is a moderator/admin
function is_forum_moderator($catid,$name) {
	if (!strlen($name))
		return false;
	// query the global array of forum moderators for that category id
	$catid=(int)$catid;
	return in_array($name, get_forum_moderators($catid));
}

## estabilish if an user can edit a post, given the post category id ($catid) and the category locked setting
function can_user_edit($author_id, $catid, $locked) {
	global $my;

	// anonymous users cannot edit any post
	if (!$my->gid) return false;
	if ($author_id==0) {
		// managers and admins are always moderators
		if ($my->gid>=4) return true;
		// anonymous posts are subject to moderators rules
		return is_forum_moderator($catid, $my->username);
	}
	global $conn;
	// get user group id (GID)
	$row = $conn->GetRow('SELECT gid FROM #__users WHERE id='.$author_id);
	if (count($row))
		$gid = $row['gid'];
	else
	// if the user no more exists, its group id is one below manager (Publisher) so that only moderators can handle it
		$gid = 3;
	// if the group id is greater, edit is not possible
	if ($gid>$my->gid)
		return false;
	// if the group is equal and the author id is different, or if the topic is locked, allow edit only to moderators
	else if ((($gid==$my->gid) && ($author_id!=$my->id)) || $locked) {
		if ($my->gid>=4)
			return true;
		return is_forum_moderator($catid, $my->username);
	}
	return true;
}

function find_last_post($catid) {
	global $conn;
	// find the latest post for the $catid category
	$row = $conn->GetRow('SELECT id FROM #__forum_posts WHERE catid='.$catid.' ORDER BY time DESC');
	if (!count($row))
		$pid = 0;
	else
		$pid = $row['id'];
	return $pid;
}

## get the POSTed notify setting
function get_notify($thread_id=0) {
	// retrieve the flag
	$notify = in_num('notify', $_POST);
	// if found, return its boolean representation
	if (isset($notify)) return ($notify!=0);
	global $my;
	// if the user is not logged in, he cannot get notifications
	if (!$my->id)	return false;
	// if this was not a POST
	if (empty($_POST)) {
		// ?
		if (!$thread_id) return true;
		// retrieve the setting from database
		return get_db_notify($thread_id);
	}
	// this is a POST and we couldn't get the flag
	return false;
}

global $user_db_notify;
function get_db_notify($topic_id) {
	global $conn,$my,$user_db_notify;
	if (!isset($user_db_notify)) {
		$usr = $conn->GetRow('SELECT user_id FROM #__forum_notifies WHERE user_id='.$my->id.' AND topic_id='.$topic_id);
		$user_db_notify = (count($usr)!=0);
	}
	return $user_db_notify;
}

function get_user_info($id) {
	global $conn, $my;
	$row1=$conn->GetRow("SELECT * FROM #__users WHERE id=".$id);
	if (!count($row1))
		return array();
	$row2=$conn->GetRow("SELECT * FROM #__forum_users WHERE id=".$id);
	
	if(!count($row2)){
		$conn->Execute("INSERT INTO #__forum_users (id,information,url,posts) VALUES ($id,'','',1)");
		$row2=$conn->GetRow("SELECT * FROM #__forum_users WHERE id=".$id);
	}
	return array_merge($row1,$row2);
}

function sanitize($text) {
	global $params;
	//replace bad words
	$arr=array_map('trim', explode(",",$params->get('bad_words')));
	$c=count($arr);
	if ($c) return $text;
	$filtered = array();
	foreach($arr as $word) {
		$filtered[] = '/'.str_replace('/', '\\/', preg_quote($word)).'/i';
	}
	return preg_replace($filtered, $params->get('rep_word'), $text);
}

function forum_category_access($catid) {
	global $conn, $my, $access_sql;
	$row = $conn->GetRow("SELECT id FROM #__forum_categories WHERE locked=0 AND id=$catid $access_sql");
	return (count($row)!=0);
}

// does the user have moderator rights over this post?
function moderator_rights($catid, $post_uid, $row_locked) {
	global $my;
	return ($my->gid>=4 || is_forum_moderator($catid, $my->username) || can_user_edit($post_uid,$catid,$row_locked));
}

## returns an array of categories where a topic can be moved into
function get_move_targets() {
	global $conn, $my;
	$rows = $conn->SelectArray('#__forum_categories', 'id,name', ' WHERE access<='.$my->gid.' AND editgroup<='.$my->gid);
	$targets = array();
	foreach ($rows as $row) {
		$targets[(int)$row['id']] = $row['name'];
	}
	return $targets;
}

/*
	if catid == -1 then no category is pre-selected
	if parent_id == -1 then include also sections
	if parent_id == 0 include categories of invisible section 0 (forum categories without parent section)
	if ro == false then show only unlocked/writable categories
*/
function _write_forum_categories ($catid, $ro = true, $parent_id = -1) {
	global $access_sql, $edit_sql;
	if ($ro)
		$cat_access = $access_sql;
	else
		$cat_access = $edit_sql;
	if ($parent_id != -1) {
		__write_forum_subcategories('', $catid, $cat_access, $parent_id);
	} else {
		global $conn;
		$rsa = $conn->SelectArray('#__categories', 'id,name'," WHERE section='com_forum' ".$cat_access);
		foreach($rsa as $sect) {
			echo '<option value="">'.$sect['name']."</option>";
			__write_forum_subcategories('&nbsp;&nbsp;&nbsp;&nbsp;', $catid, $cat_access, $sect['id']);
		}
	}
}

function __write_forum_subcategories($tab, $catid, $cat_access, $parent_id) {
	global $conn;
	$rsa=$conn->SelectArray('#__forum_categories', 'id,name', ' WHERE parent_id='.$parent_id.' '.$cat_access);
	foreach($rsa as $row) {
		// the category name is already encoded
		echo '<option value="'.$row['id'].'"';
		if ($row['id'] == $catid)
			echo ' selected="selected"';
		echo '>'.$tab.$row['name']."</option>";
	}
}

function get_post_cat($post_id, $cat_extra = '', $post_extra = '') {
	global $conn;
	$crow = $conn->SelectRow('#__forum_posts', 'catid'.$post_extra, ' WHERE id='.$post_id);
	if (!$crow) {
		global $d;
		CMSResponse::NotFound();
		return false;
	}
	global $access_sql;
	$row = $conn->SelectRow('#__forum_categories', 'id,name'.$cat_extra, ' WHERE id='.$crow['catid'].
						' '.$access_sql);
	if (!$row) {
		global $d;
		CMSResponse::Unauthorized();
		return false;
	}
	if (strlen($post_extra))
		return array($crow, $row);
	return $row;
}

?>