<?php if(!defined('_VALID')){header('Status: 404 Not Found');die;}
## Service component
# @author legolas558
#
# allows core webservices

$service = in_raw('service', $_GET);

switch ($service) {
	default:
		CMSResponse::BadRequest();
	break;
	case 'captcha':
		if (!$params->get('captcha', 1)) {
			CMSResponse::Unavailable();
			break;
		}
		header('Content-Type: image/png');
		header("Expires: Mon, 20 April 2007 14:14:41 GMT"); // date in the past
		header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT"); // always modified
		header("Cache-Control: no-store, no-cache, must-revalidate"); // HTTP/1.1
		header("Pragma: no-cache"); // HTTP/1.0

		include $d_root.'classes/captcha/captcha.php';
			
		$code = generateCode(5);
		
		$_SESSION[$d_uid.'-captcha'] = md5($code);
		
		$captcha = new Captcha($code, $d_root.'classes/captcha/davis.ttf', 100, 40, 3, 8);
	break;
	case 'xmlrpc':
		if (!$params->get('xmlrpc', 0)) {
			CMSResponse::Unavailable();
			break;
		}
		require $d_root.'classes/xmlrpc/functions.php';
		require $d_root.'classes/xmlrpc/server.php';
		require $d_root.'classes/xmlrpc/wrappers.php';
	break;
	case 'admin_menu':
		// always disallow access to menu when not logged in
		if ($my->gid<3) {
			CMSResponse::Unauthorized('', false);
			break;
		}
		include $d_root.'admin/classes/adminmenu.php';
		AdminMenu::Head(true);
		AdminMenu::Content(true);
	break;
/*	case 'basejs':
		// base javascript used by all websites
		// currently used by WYSIWYG editors to localize website root
		header('Content-Type: text/javascript');
		header('Cache-Control: public');
		echo 'var _d_subsite_path = "'.$d->SubsitePath().'";';
	break;	*/
}

?>