<?php
## Documentation proxy
# @author legolas558
#
# Redirects to Drake CMS documentation or
# offers a list of available documentations if
# the user language does not match

// copied from core.php

function mt_float()
{
   $a = explode(' ', microtime());
   return ((float)$a[0] + (float)$a[1]);
}

//L: Even before Creation, Drake realized drakes can make errors...
$page_start_time = mt_float();

define('_VALID', 1);

require 'version.php';

include $d_root.'includes/functions.php';

if (file_exists( $d_root.$d_private.'config.php' )) {
	include $d_root.$d_private.'config.php';
} else {
	$d_docs_server = '';
	$d_db = 'none';	// for error recovering
	$d_rand = random_string(6);
}

include $d_root.'includes/errtrace.php';

set_error_handler('Drake_error_handler');

error_reporting( -1 );

include $d_root.'includes/dracon.php';

//include $d_root.'includes/adodb.php';

/*** DOCS proxy starts here ***/

include $d_root.'classes/http.php';

//if there is a custom server defined, redirect to there
if (strlen($d_docs_server)) {
	$url = CMSRequest::QueryString();
	if (strlen($url))
		$url = '?'.$url;
	$url = $d_docs_server.'docs.php'.$url;
	header('Location: '.$url);
	exit();
}

//TODO: might be optimized
//include $d_root.'includes/header.php';

include $d_root.'classes/user.php';

$my = new CMSUser();
$my->Initialize(false);

//NOTE: documentation is active also when website is offline (used during installation), unless you specify a custom remote server for it

// get the raw language (supplied by browser or $d_defaultlang)
$raw_lang = $my->recognize_lid();
	
include $d_root.'lang/'.$raw_lang.'/common.php';

// parse a request for a specific page
$page = in_raw('page', $_GET);
if (isset($page)) {
	// dots are not allowed
	if (strpos($page, '.')!==false) {
		CMSResponse::BadRequest();
		exit;
	}
} else // if no page was requested, defaults to the index page
	$page = 'index';
	
// if the page does exist
if (is_file($d_root.'lang/'.$my->lang.'/docs/'.$page.'.htm')) {
	// go show directly the documentation in the correct language
	CMSResponse::Move($d_subpath.'lang/'.$my->lang.'/docs/'.$page.'.htm');
}

	// if the raw language exists, give precedence to the current user language
	// will catch user preference
	if (is_dir($d_root.'lang/'.$raw_lang))
		$raw_lang = $my->lang;

	include $d_root.'includes/langsel.php';
	
	$languages = available_languages();
	
/*	$languages = array();
	foreach($all_languages as $lang => $lname) {
		if (is_file($d_root.'lang/'.$lang.'/docs/'.$page.'.htm'))
			$languages[$lang] = $lname;
	} $all_languages = null; */
	
	if (!count($languages)) {
		CMSResponse::NotFound();
		exit();
	}

	// if the user's language has an official documentation translation, redirect to it (remote)
	if (isset($languages[$raw_lang])) {
		header('Location: '.$d__server.'lang/'.$raw_lang.'/docs/'.$page.'.htm');
		exit();
	}
	
	// this page is internationalized too
	include $d_root.$d_subpath.'lang/'.$my->lang.'/includes/docs.php';
	
	// show a list of documentation sources with relative language
?><html><head><link href="<?php echo $d_subpath; ?>docs/docs.css" rel="stylesheet" type="text/css" /></head><body>
	<h1><?php echo _DOCS_HEADER; ?></h1>
	<p><?php echo sprintf(_DOCS_NOT_AVAILABLE, '<strong>'.xhtml_safe($page).'.htm</strong>', '<strong>'.strtoupper($raw_lang).'</strong>');
	// we are not using raw_strtoupper() because localization does not happen in docs.php
?></p>
	<p><?php echo _DOCS_CHOOSE_ALTERNATIVE; ?>:</p>
	<ul><?php
	
	foreach ($languages as $cc => $name) {
		$url = 'lang/'.$cc.'/docs/'.$page.'.htm';
		if (!is_file($d_root.$url)) {
			$name.= sprintf(_DOCS_FROM_SERVER, $d__server);
			$url = $d__server.$url;
		} else
			$url = $d_subpath.$url;
		echo '<li><a href="'.$url.'">'.xhtml_safe($page).'.htm in '.$name.
				' (<strong>'.strtoupper($cc).'</strong> <img border="0" alt="'.
				strtoupper($cc).'" src="'.$d_subpath.'lang/'.$cc.'/flag.png" align="absmiddle" />)</a></li>';
	}
	?>
	</ul>
	</body></html>
