<?php if(!defined('_VALID')){header('Status: 404 Not Found');die;}
## Drake CMS common install/uninstall procedures 
# @author legolas558
# 
# contains common utility functions to modify installation

function install_sql(&$conn, $filename, $pgcheck=false, $verbose = false, $dropfilter = false) {
	global $d_db;
	$query = file_get_contents($filename);
	
	if ($pgcheck)
		$query = preg_replace('/id int(?:eger) AUTO_INCREMENT/i', 'id SERIAL', $query);

	$query_arr = split_sql($query, true);
	$err = 0;
	foreach($query_arr as $query) {
		if (strpos($query, 'DROP')===0)
			@$conn->Execute($query);
		else if (!$dropfilter) {
			if ($conn->Execute($query)===false) {
				$err++;
				echo '<a href="javascript:alert(\''.js_enc($query).'\')" title="Click to read the faulty SQL">'.$conn->ErrorMsg().'</a><br />';
				flush();
				continue;
			}
			if ($verbose)
				echo '<p>'.$conn->ErrorMsg().'</p>';
		}
	}
	
	if ($verbose) {
		$c = count($query_arr);
		echo '<p>'.($c-$err).'/'.$c.' queries executed from file '.fix_root_path($filename).'</p>';
	}
	
	return $err;
}

function install_cms(&$conn, $d_db, $verbose = false) {
	global $d_root;
	//L: we should use adoDB lite datadict for SQL portability
	$err = install_sql($conn, $d_root.'admin/includes/database.sql.php', (strpos($d_db, 'postgres')===0), $verbose );

	if (!$err) {
		// insert the Drake CMS core package
		$conn->Insert('#__packages', '(type,name,version)', "'core', 'Drake CMS', '".sql_encode(drake_version(true))."'");
		
		$err = install_sql($conn, $d_root.'install/inserts.sql.php', false, $verbose);
	}
	return $err;
}

function admin_pwd() {
	global $conn, $my;
	// security check
	$row = $conn->SelectRow('#__users', 'password',' WHERE id='.$my->id);
	return $row['password'];
}

function admin_insert(&$newconn, $apwdh) {
	global $my, $time;
	$newconn->Insert('#__users', '(name,username,email,password,registerDate,lastvisitDate,gid,lang,published)',
			"'".sql_encode($my->name)."', '".sql_encode($my->username).
			"', '".sql_encode($my->email)."', '$apwdh', $time, $time, 5, '".$my->lang."', 1");
}

?>
